## Magnetize the nearest item. If the item was picked up then apply durability penalty. If the player failed 
## to pick up the previous magentized item, return 0 without magnetizing. Otherwise return 1
execute if entity @s[advancements={m_trader_revamp:inventory_changed=false}] run return 0

# Attempt to magnetize nearest item or arrow. '&boolean' is 0 when an item or arrow has not been magnetized
scoreboard players set &boolean multipack.temp 0
execute store success score &boolean multipack.temp run tp @e[distance=1.4..16,type=item,nbt={PickupDelay:0s},sort=nearest,limit=1] @s
execute if score &boolean multipack.temp matches 0 store success score &boolean multipack.temp as @e[distance=1.4..8,type=#arrows,nbt={pickup:1b,inGround:1b},sort=nearest,limit=1] run function m_trader_revamp:items/item_magnet/magnetize_arrow
execute if score &boolean multipack.temp matches 0 run return 1

# Differentiate between mainhand and offhand then apply durability penalty
execute if predicate m_trader_revamp:items/item_magnet run scoreboard players set &itemID multipack.temp 1
execute if predicate m_trader_revamp:items/item_magnet_offhand run scoreboard players set &itemID multipack.temp -1
execute if function m_trader_revamp:items/damage_item if score &itemDamage multipack.temp matches 250.. at @s run function m_trader_revamp:items/break_item {"item":"amethyst_shard"}

advancement revoke @s only m_trader_revamp:inventory_changed
return 1
